package com.nisum.myteam.controller;

import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.nisum.myteam.exception.handler.MyTeamException;
import com.nisum.myteam.exception.handler.ResponseDetails;
import com.nisum.myteam.model.dao.OrgLocation;
import com.nisum.myteam.service.IOrgLocationService;

import lombok.extern.slf4j.Slf4j;

@RestController
@Slf4j
public class OrgLocationController {

	@Autowired
	IOrgLocationService orgLocationService;

	// @RequestMapping(value = "/getLocations"
	@RequestMapping(value = "/organization/locations/", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<?> getLocations(HttpServletRequest request) throws MyTeamException {

		List<String> locationsList = orgLocationService.getLocations().stream()
				.filter(e -> (e.isActiveStatus() == true)).map(OrgLocation::getLocation).sorted()
				.collect(Collectors.toList());
		log.info("getLocations " + locationsList);

		ResponseDetails getRespDetails = new ResponseDetails(new Date(), 905,
				"Retrieved Organization Locations  successfully", "Organization Locations List", locationsList,
				request.getRequestURI(), "Organization Location Details", null);

		return new ResponseEntity<>(getRespDetails, HttpStatus.OK);

	}
}
